## grub2 2.04.25

=== debian/changelog ===
grub2 (2.04.25-18) unstable; urgency=medium

  * 修改if语句的fi结尾

 -- Angie <doucaixia@untiontech.com>  Tue, 19 Jul 2022 09:58:30 +0800

grub2 (2.04.24-18) unstable; urgency=medium

  * fix chang log

 -- wangyouwan <wangyouwan@untiontech.com>  Mon, 18 Jul 2022 15:17:25 +0800

grub2 (2.04.23-18) unstable; urgency=medium
 
  * add patches from loongson(5 patches):
  *   fix-acpi-memmap-and-linux-template.patch add-initrd-phy-addr-and-size-to-kernel.patch
  *   fix-efi-suffix-for-adapt-to-Loongarch64-uefi.patch
  *   support-BPI01002-and-phy-addr-BIOS.patch LoongArch64-add-fdt-support.patch
  * These patches have been summarized into one patch:
  *   uos-add-loongson-modify-for-loongarch.patch

 -- Angie.J <doucaixia@uniontech.com>  Fri, 15 Jul 2022 12:30:25 +0800

grub2 (2.04.22-18) unstable; urgency=medium

  * fix grub-efi-loongarch64-bin postinst

 -- wangyouwan <wangyouwan@uniontech.com>  Thu, 14 Jul 2022 10:51:17 +0800

grub2 (2.04.21-18) unstable; urgency=medium

  * SECURITY UPDATE: Crafted PNG grayscale images may lead to out-of-bounds
    write in heap.
    - 0070-video-readers-png-Drop-greyscale-support-to-fix-heap.patch:
      video/readers/png: Drop greyscale support to fix heap out-of-bounds write
    - CVE-2021-3695
  * SECURITY UPDATE: Crafted PNG image may lead to out-of-bound write during
    huffman table handling.
    - 0071-video-readers-png-Avoid-heap-OOB-R-W-inserting-huff-.patch:
      video/readers/png: Avoid heap OOB R/W inserting huff table items
    - CVE-2021-3696
  * SECURITY UPDATE: Crafted JPEG image can lead to buffer underflow write in
    the heap.
    - 0076-video-readers-jpeg-Block-int-underflow-wild-pointer-.patch:
      video/readers/jpeg: Block int underflow -> wild pointer write
    - CVE-2021-3697
  * SECURITY UPDATE: Integer underflow in grub_net_recv_ip4_packets
    - 0079-net-ip-Do-IP-fragment-maths-safely.patch: net/ip: Do IP fragment
      maths safely
    - CVE-2022-28733
  * SECURITY UPDATE: Out-of-bounds write when handling split HTTP headers
    - 0085-net-http-Fix-OOB-write-for-split-http-headers.patch: net/http: Fix
      OOB write for split http headers
    - CVE-2022-28734
  * Various fixes as a result of fuzzing and static analysis:
    - 0067-kern-file-Do-not-leak-device_name-on-error-in-grub_f.patch:
      kern/file: Do not leak device_name on error in grub_file_open()
    - 0068-video-readers-png-Abort-sooner-if-a-read-operation-f.patch:
      video/readers/png: Abort sooner if a read operation fails
    - 0069-video-readers-png-Refuse-to-handle-multiple-image-he.patch:
      video/readers/png: Refuse to handle multiple image headers
    - 0072-video-readers-png-Sanity-check-some-huffman-codes.patch:
      video/readers/png: Sanity check some huffman codes
    - 0073-video-readers-jpeg-Abort-sooner-if-a-read-operation-.patch:
      video/readers/jpeg: Abort sooner if a read operation fails
    - 0074-video-readers-jpeg-Do-not-reallocate-a-given-huff-ta.patch:
      video/readers/jpeg: Do not reallocate a given huff table
    - 0075-video-readers-jpeg-Refuse-to-handle-multiple-start-o.patch:
      video/readers/jpeg: Refuse to handle multiple start of streams
    - 0077-normal-charset-Fix-array-out-of-bounds-formatting-un.patch:
      normal/charset: Fix array out-of-bounds formatting unicode for display
    - 0078-net-netbuff-Block-overly-large-netbuff-allocs.patch:
      net/netbuff: Block overly large netbuff allocs
    - 0080-net-dns-Fix-double-free-addresses-on-corrupt-DNS-res.patch:
      net/dns: Fix double-free addresses on corrupt DNS response
    - 0081-net-dns-Don-t-read-past-the-end-of-the-string-we-re-.patch:
      net/dns: Don't read past the end of the string we're checking against
    - 0082-net-tftp-Prevent-a-UAF-and-double-free-from-a-failed.patch:
      net/tftp: Prevent a UAF and double-free from a failed seek
    - 0083-net-tftp-Avoid-a-trivial-UAF.patch: net/tftp: Avoid a trivial UAF
    - 0084-net-http-Do-not-tear-down-socket-if-it-s-already-bee.patch:
      net/http: Do not tear down socket if it's already been torn down
    - 0086-net-http-Error-out-on-headers-with-LF-without-CR.patch:
      net/http: Error out on headers with LF without CR
    - 0087-fs-f2fs-Do-not-read-past-the-end-of-nat-journal-entr.patch:
      fs/f2fs: Do not read past the end of nat journal entries
    - 0088-fs-f2fs-Do-not-read-past-the-end-of-nat-bitmap.patch:
      fs/f2fs: Do not read past the end of nat bitmap
    - 0089-fs-f2fs-Do-not-copy-file-names-that-are-too-long.patch:
      fs/f2fs: Do not copy file names that are too long
    - 0090-fs-btrfs-Fix-several-fuzz-issues-with-invalid-dir-it.patch:
      fs/btrfs: Fix several fuzz issues with invalid dir item sizing
    - 0091-fs-btrfs-Fix-more-ASAN-and-SEGV-issues-found-with-fu.patch:
      fs/btrfs: Fix more ASAN and SEGV issues found with fuzzing
    - 0092-fs-btrfs-Fix-more-fuzz-issues-related-to-chunks.patch:
      fs/btrfs: Fix more fuzz issues related to chunks

 -- Youwan Wang <wangyouwan@uniontech.com>  Fri, 17 Jun 2022 15:00:31 +0800

grub2 (2.04.20-18) unstable; urgency=medium
  
  * fix: sb failed in HUAWEI machines
  *
 -- liuqi <liuqi@uniontech.com>  Tue, 14 Jun 2022 16:30:25 +0800

grub2 (2.04.19-18) unstable; urgency=medium

  * fix Add grub-efi-loongarch64-bin postinst

 -- wangyouwan <wangyouwan@uniontech.com>  Thu, 12 May 2022 20:59:46 +0800

grub2 (2.04.18-18) unstable; urgency=medium

  * fix no grub background on huawei pc 
  * 

 -- Cai Tongxun <caitongxun@uniontech.com>  Wed, 20 Apr 2022 16:01:40 +0800

grub2 (2.04.17-18) unstable; urgency=medium

  * fix loongarch64 gfxterm output

 -- Angie.J <doucaixia@uniontech.com>  Tue, 29 Mar 2022 14:26:42 +0800

grub2 (2.04.16-18) unstable; urgency=medium

  * fix arm64 terminal output console

 -- wangyouwan <wangyouwan@uniontech.com>  Wed, 02 Mar 2022 19:32:05 +0800

grub2 (2.04.15-18) unstable; urgency=medium

  * fix rules
  * do not print “Welcome to GRUB!”


