## grub2 2.04.28

=== debian/changelog ===
grub2 (2.04.28-18) unstable; urgency=medium

  * fix CVE-2022-2601 CVE-2022-3775.

 -- liaoyuan <liaoyuan@uniontech.com>  Thu, 02 Feb 2023 15:34:13 +0800

grub2 (2.04.27-18) unstable; urgency=medium

  * osdep: Introduce include/grub/osdep/major.h and use it
  * ... to factor out fix for glibc 2.25 introduced in 7a5b301e3 (build: Use
  * AC_HEADER_MAJOR to find device macros).
  *
  * Note: Once glibc 2.25 is old enough and this fix is not needed also
  * AC_HEADER_MAJOR in configure.ac should be removed.
  * grub.git commit: https://git.savannah.gnu.org/cgit/grub.git/commit/?id=e94b4f23277f7572aacbbeae50b8927e03be148a
  * 
  * osdep/linux/hostdisk: Use stat() instead of udevadm for partition lookup
  * The sysfs_partition_path() calls udevadm to resolve the sysfs path for
  * a block device. That can be accomplished by stating the device node
  * and using the major/minor to follow the symlinks in /sys/dev/block/.
  * 
  * This cuts the execution time of grub-mkconfig to somewhere near 55% on
  * system without LVM (which uses libdevmapper instead sysfs_partition_path()).
  * 
  * Remove udevadm call as it does not help us more than calling stat() directly.
  * grub.git commit: https://git.savannah.gnu.org/cgit/grub.git/commit/?id=1ea4e5ef09c06552402bf676ce262a661372f08d
  * 
  * fix os-prober-excute slow.

 -- xiebo <xiebo1@uniotech.com>  Tue, 06 Sep 2022 17:41:57 +0800

grub2 (2.04.26-18) unstable; urgency=medium

  * remove system setup on huawei pc

 -- Youwan Wang <wangyouwan@uniontech.com>  Thu, 28 Jul 2022 09:12:10 +0800
