=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,12 @@
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
 DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
 
-HOST_CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) -pie -fPIC
+export DEB_BUILD_MAINT_OPTIONS = optimize=-lto
+
+HOST_CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
 # -O3 (default on Ubuntu ppc64el) introduces various -Werror failures, and
 # isn't worth it here.
-HOST_CFLAGS := -Wall -Wno-error=unused-result $(shell dpkg-buildflags --get CFLAGS | perl -pe 's/-O3\b/-O2/') -pie -fPIC
+HOST_CFLAGS := -Wall -Wno-error=unused-result $(shell dpkg-buildflags --get CFLAGS | perl -pe 's/-O3\b/-O2/')
 HOST_LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
 
 export DEB_HOST_ARCH
@@ -23,17 +25,13 @@
 export TARGET_CPPFLAGS := -Wno-unused-but-set-variable
 export TARGET_LDFLAGS := -no-pie
 
-ifneq (,$(filter sparc sparc64,$(DEB_HOST_ARCH_CPU)))
-export TARGET_CCASFLAGS := -fno-PIE
-endif
-
 # Ensure that debhelper doesn't try to set these; we need to be careful
 # about HOST_* vs. TARGET_*.
 export CPPFLAGS :=
 export CFLAGS :=
 export LDFLAGS :=
 
-ifeq (,$(shell which qemu-system-i386 2>/dev/null))
+ifeq (,$(shell command -v qemu-system-i386))
 with_check := no
 else
 with_check := yes
@@ -55,7 +53,7 @@
 # REAL_PACKAGES build an actual grub variant (and therefore have both configure
 # and build stages). EXTRA_PACKAGES do not build grub but may depend on a
 # REAL_PACKAGE (and therefore only have a build stage)
-REAL_PACKAGES = grub-common grub-emu grub-pc grub-coreboot grub-efi-ia32 grub-efi-amd64 grub-efi-ia64 grub-efi-arm grub-efi-arm64 grub-ieee1275 grub-firmware-qemu grub-uboot grub-xen grub-yeeloong grub-efi-loongarch64
+REAL_PACKAGES = grub-common grub-emu grub-pc grub-coreboot grub-efi-ia32 grub-efi-amd64 grub-efi-ia64 grub-efi-arm grub-efi-arm64 grub-ieee1275 grub-firmware-qemu grub-uboot grub-xen grub-yeeloong
 EXTRA_PACKAGES = grub-rescue-pc grub-xen-host
 
 ifneq (,$(filter i386 amd64,$(DEB_HOST_ARCH_CPU)))
@@ -64,8 +62,6 @@
 COMMON_PLATFORM := ieee1275
 else ifeq (mipsel,$(DEB_HOST_ARCH_CPU))
 COMMON_PLATFORM := yeeloong
-else ifeq (loongarch64,$(DEB_HOST_ARCH_CPU))
-COMMON_PLATFORM := efi-loongarch64
 else ifeq (ia64,$(DEB_HOST_ARCH_CPU))
 COMMON_PLATFORM := efi-ia64
 else ifeq (arm,$(DEB_HOST_ARCH_CPU))
@@ -95,9 +91,6 @@
 DEFAULT_TIMEOUT := 5
 FLICKER_FREE_BOOT := no
 endif
-
-confflags += \
-	--enable-quiet-boot
 
 ifeq ($(FLICKER_FREE_BOOT),yes)
 DEFAULT_HIDDEN_TIMEOUT := 0
@@ -122,8 +115,6 @@
 debian/stamps/build-grub-efi-amd64 install/grub-efi-amd64: export SB_EFI_NAME := x64
 debian/stamps/build-grub-efi-arm64 install/grub-efi-arm64: export SB_PLATFORM := arm64-efi
 debian/stamps/build-grub-efi-arm64 install/grub-efi-arm64: export SB_EFI_NAME := aa64
-debian/stamps/build-grub-efi-loongarch64 install/grub-efi-loongarch64: export SB_PLATFORM := loongarch64-efi
-debian/stamps/build-grub-efi-loongarch64 install/grub-efi-loongarch64: export SB_EFI_NAME := loongarch64-efi
 SB_PACKAGE :=
 ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
 ifeq ($(DEB_HOST_ARCH),amd64)
@@ -175,18 +166,6 @@
 	env -u DH_OPTIONS GRUB_CONTRIB=$(CURDIR)/debian/grub-extras-enabled \
 		PYTHON=python3 \
 		dh_autoreconf -- ./autogen.sh
-	for patchname in \
-		0001-Support-POTFILES-shell \
-		0002-Handle-gettext_printf-shell-function \
-		0003-Make-msgfmt-output-in-little-endian \
-		0004-Use-SHELL-rather-than-bin-sh; do \
-		patch -d po -p3 \
-		< "debian/gettext-patches/$$patchname.patch"; \
-	done
-# fix update-grub
-	if [ "loongarch64" = "$(DEB_HOST_ARCH_CPU)" ] ; then \
-		mv debian/update-grub.loongarch debian/update-grub; \
-	fi
 
 debian/stamps/configure-grub-common: debian/stamps/configure-grub-$(COMMON_PLATFORM)
 	touch $@
@@ -204,8 +183,24 @@
 	mkdir -p debian/stamps obj/$(package)
 	dh_auto_configure -- $(confflags) --with-platform=efi --target=i386-pe --program-prefix=""
 	touch $@
-debian/stamps/configure-grub-efi-loongarch64:
+debian/stamps/configure-grub-efi-amd64:
 	mkdir -p debian/stamps $(subst debian/stamps/configure-,obj/,$@)
-	dh_auto_configure -- $(confflags) --program-prefix= --disable-dependency-tracking --with-platform=efi --disable-werror
-	touch $@
-debian/stamps/configure-grub-efi-amd64:
+	dh_auto_configure -- $(confflags) --with-platform=efi --target=amd64-pe --program-prefix=""
+	touch $@
+debian/stamps/configure-grub-efi-ia64 debian/stamps/configure-grub-efi-arm debian/stamps/configure-grub-efi-arm64:
+	mkdir -p debian/stamps $(subst debian/stamps/configure-,obj/,$@)
+	dh_auto_configure -- $(confflags) --with-platform=efi
+	touch $@
+
+debian/stamps/configure-grub-xen-i386 debian/stamps/configure-grub-xen-amd64:
+	mkdir -p debian/stamps obj/$(package)
+	dh_auto_configure -- $(confflags) --with-platform=xen --target=$(subst debian/stamps/configure-grub-xen-,,$@) --program-prefix=""
+	touch $@
+debian/stamps/configure-grub-xen-pvh-i386:
+	mkdir -p debian/stamps obj/$(package)
+	dh_auto_configure -- $(confflags) --with-platform=xen_pvh --target=i386 --program-prefix=""
+	touch $@
+debian/stamps/configure-grub-xen: debian/stamps/configure-grub-xen-i386 debian/stamps/configure-grub-xen-amd64 debian/stamps/configure-grub-xen-pvh-i386
+	touch $@
+
+debian/stamps/configure-grub-firmware-qemu:
